local AL = AceLibrary("AceLocale-2.2"):new("AtlasLoot");

-- Colours stored for code readability
local GREY = "|cff999999";
local RED = "|cffff0000";
local WHITE = "|cffFFFFFF";
local GREEN = "|cff1eff00";
local PURPLE = "|cff9F3FFF";
local BLUE = "|cff0070dd";
local ORANGE = "|cffFF8400";
local INDENT = "   ";

AtlasLoot_ExtraText = {
    AuchAuchenaiCrypts = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    AuchManaTombs = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    AuchSethekkHalls = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    AuchShadowLabyrinth = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackfathomDeeps = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackrockDepths = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Set: The Gladiator"];
    };
    BlackrockSpireLower = {
        "";
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Dungeon 1/2 Sets"];
    };
    BlackrockSpireUpper = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Dungeon 1/2 Sets"];
    };
    BlackTempleStart = {
        "";
        GREY..INDENT..AL["BT Patterns/Plans"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackTempleBasement = {
        "";
        GREY..INDENT..AL["BT Patterns/Plans"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackTempleMiddle = {
        "";
        GREY..INDENT..AL["BT Patterns/Plans"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackTempleTop = {
        "";
        GREY..INDENT..AL["BT Patterns/Plans"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackTempleFull = {
        "";
        GREY..INDENT..AL["BT Patterns/Plans"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    BlackwingLair = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Tier 1/2 Sets"];
    };

    CFRTheSteamvault = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        };

    CFRSerpentshrineCavern = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        };

    CoTOldHillsbrad = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    CoTBlackMorass = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    CoTHyjal = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TheDeadmines = {
        "";
        GREY..INDENT..AL["Set: Defias Leather"];
    };
    DireMaulEast = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Dire Maul Books"];
    };
    DireMaulNorth = {
        "";
        GREY..INDENT..AL["Tribute Run"];
        GREY..INDENT..AL["Dire Maul Books"];
    };
    DireMaulWest = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Dire Maul Books"];
    };
    Gnomeregan = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    HCTheShatteredHalls = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    Karazhan = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    KarazhanStart = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    KarazhanEnd = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    MagistersTerrace = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    MoltenCore = {
        "";
        GREY..INDENT..AL["Tier 1/2 Sets"];
        GREY..INDENT..AL["Random Boss Loot"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    Naxxramas = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Tier 3 Sets"];
    };
    RazorfenDowns = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    RazorfenKraul = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TempestKeepMechanar = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TempestKeepBotanica = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TempestKeepArcatraz = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TempestKeepTheEye = {
        "";
        GREY..INDENT..AL["Legendary Items for Kael'thas Fight"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    TheRuinsofAhnQiraj = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Class Books"];
        GREY..INDENT..AL["AQ Enchants"];
        GREY..INDENT..AL["AQ20 Class Sets"];
    };
    SMArmory = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Set: Chain of the Scarlet Crusade"];
    };
    SMCathedral = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Set: Chain of the Scarlet Crusade"];
    };
    SMGraveyard = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Set: Chain of the Scarlet Crusade"];
    };
    SMLibrary = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Set: Chain of the Scarlet Crusade"];
    };
    Scholomance = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Set: Necropile Raiment"];
        GREY..INDENT..AL["Set: Cadaverous Garb"];
        GREY..INDENT..AL["Set: Bloodmail Regalia"];
        GREY..INDENT..AL["Set: Deathbone Guardian"];
    };
    ShadowfangKeep = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TheStockade = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    Stratholme = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    SunwellPlateau = {
        "";
        GREY..INDENT..AL["SP Patterns/Plans"];
        GREY..INDENT..AL["Trash Mobs"];
    };
    TheSunkenTemple = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    TheTempleofAhnQiraj = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["AQ Enchants"];
        GREY..INDENT..AL["AQ40 Class Sets"];
        GREY..INDENT..AL["AQ Opening Quest Chain"];
    };
    Uldaman = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    WailingCaverns = {
        "";
        GREY..INDENT..AL["Set: Embrace of the Viper"];
    };
    ZulAman = {
        "";
        GREY..INDENT..AL["Timed Reward Chest"];
        GREY..INDENT..AL["Trash Mobs"];
        "";
    };
    ZulFarrak = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
    };
    ZulGurub = {
        "";
        GREY..INDENT..AL["Trash Mobs"];
        GREY..INDENT..AL["Random Boss Loot"];
        GREY..INDENT..AL["ZG Class Sets"];
        GREY..INDENT..AL["ZG Enchants"];
    };
    AlteracValleyNorth = {
        "";
        GREEN..AL["Misc. Rewards"];
        GREEN..AL["Superior Rewards"];
        GREEN..AL["Epic Rewards"];
    };
    AlteracValleySouth = {
        "";
        GREEN..AL["Misc. Rewards"];
        GREEN..AL["Superior Rewards"];
        GREEN..AL["Epic Rewards"];
    };
    ArathiBasin = {
        "";
        GREEN..AL["Misc. Rewards"];
        GREEN..AL["Level 20-29 Rewards"];
        GREEN..AL["Level 20-29 Rewards"];
        GREEN..AL["Level 30-39 Rewards"];
        GREEN..AL["Level 40-49 Rewards"];
        GREEN..AL["Level 40-49 Rewards"];
        GREEN..AL["Level 50-59 Rewards"];
        GREEN..AL["Level 60 Rewards"];
        "";
        GREEN..AL["Arathi Basin Sets"];
    };
    WarsongGulch = {
        "";
        GREEN..AL["Misc. Rewards"];
        GREEN..AL["Level 10-19 Rewards"];
        GREEN..AL["Level 20-29 Rewards"];
        GREEN..AL["Level 30-39 Rewards"];
        GREEN..AL["Level 40-49 Rewards"];
        GREEN..AL["Level 50-59 Rewards"];
        GREEN..AL["Level 60 Rewards"];
    };    
};