﻿--[[ SLDataText - Copyright (C) 2008 Jeff "Taffu" Fancher | Version: 1.02 | License: GPL v3.0 ]]
--[[ Colors.lua - Revised: 04/01/2008 ]]

local SLDataText = LibStub("AceAddon-3.0"):GetAddon("SLDataText")
local L = LibStub("AceLocale-3.0"):GetLocale("SLDataText")

-- This is the color table that's used with SLDataText Modules/Plugins
SLDataText.ColorTable = {
    -- When adding your own colors...make sure to follow this format: ["YOURCOLORNAME"] = "|cffYOURHEXCOLOR",
    -- (You can copy & paste this, and fill in the area's in caps with your info)
    
    -- Note:
    -- The prefix |cff is used in World of Warcraft with hex colors and is required for the color to work properly.
    -- If your color format looks like this:
    -- ["YOURCOLORNAME"] = "87FFE4", ... it will not work, because it requires |cff before the actual hex color.
    
    -- Localized Class Colors for client-provided class details associated with Guild & Friend List
    -- Requires localized names of the classes to function properly
    
    ["enUS"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
    
        ["Druid"] = "|cffff7d0a",
        ["Hunter"] = "|cffabd473",
        ["Mage"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Priest"] = "|cffffffff",
        ["Rogue"] = "|cfffff569",
        ["Shaman"] = "|cff2459ff",
        ["Warlock"] = "|cff9482ca",
        ["Warrior"] = "|cffc79c6e",
    },
    ["frFR"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
        ["Druide"] = "|cffff7d0a",
        ["Chasseur"] = "|cffabd473",
        ["Mage"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Pr阾re"] = "|cffffffff",
        ["Escroc"] = "|cfffff569",
        ["Shaman"] = "|cff2459ff",
        ["Warlock"] = "|cff9482ca",
        ["Guerrier"] = "|cffc79c6e",
    },
    --[[ deDE Locale Data provided by LiaDavinia @ WoWI ]]
    ["deDE"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
        ["Druide"] = "|cffff7d0a",
        ["J\195\164ger"] = "|cffabd473",
        ["Magier"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Priester"] = "|cffffffff",
        ["Schurke"] = "|cfffff569",
        ["Schamane"] = "|cff2459ff",
        ["Hexenmeister"] = "|cff9482ca",
        ["Krieger"] = "|cffc79c6e",
        ["Druidin"] = "|cffff7d0a",
        ["J\195\164gerin"] = "|cffabd473",
        ["Magierin"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Priesterin"] = "|cffffffff",
        ["Schurkin"] = "|cfffff569",
        ["Schamanin"] = "|cff2459ff",
        ["Hexenmeisterin"] = "|cff9482ca",
        ["Kriegerin"] = "|cffc79c6e",
    },
    ["koKR"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
        ["Druid"] = "|cffff7d0a",
        ["Hunter"] = "|cffabd473",
        ["Mage"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Priest"] = "|cffffffff",
        ["Rogue"] = "|cfffff569",
        ["Shaman"] = "|cff2459ff",
        ["Warlock"] = "|cff9482ca",
        ["Warrior"] = "|cffc79c6e",
    },
    --[[ zhCN & zhTW Locale Data provided by Digmouse @ WoWI ]]
    ["zhCN"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
       ["德鲁伊"] = "|cffff7d0a",
        ["猎人"] = "|cffabd473",
        ["法师"] = "|cff69ccf0",
        ["圣骑士"] = "|cfff58cba",
        ["牧师"] = "|cffffffff",
        ["潜行者"] = "|cfffff569",
        ["萨满祭司"] = "|cff2459ff",
        ["术士"] = "|cff9482ca",
        ["战士"] = "|cffc79c6e",
		
    },
    ["zhTW"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
        ["德魯伊"] = "|cffff7d0a",
        ["獵人"] = "|cffabd473",
        ["法師"] = "|cff69ccf0",
        ["圣騎士"] = "|cfff58cba",
        ["牧師"] = "|cffffffff",
        ["盜賊"] = "|cfffff569",
        ["薩滿"] = "|cff2459ff",
        ["術士"] = "|cff9482ca",
        ["戰士"] = "|cffc79c6e",
    },
    ["ruRU"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
        ["Druid"] = "|cffff7d0a",
        ["Hunter"] = "|cffabd473",
        ["Mage"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Priest"] = "|cffffffff",
        ["Rogue"] = "|cfffff569",
        ["Shaman"] = "|cff2459ff",
        ["Warlock"] = "|cff9482ca",
        ["Warrior"] = "|cffc79c6e",
    },
    ["esES"] = {
        ["White"] = "|cffFFFFFF",
        ["Yellow"] = "|cffFFFF00",
        ["Gold"] = "|cffFFD700",
        ["Green"] = "|cff008000",
        ["Brown"] = "|cffA52A2A",
        ["Red"] = "|cffFF0000",
        ["Orange"] = "|cffFFA500",
        ["Pink"] = "|cffFFC0CB",
        ["Purple"] = "|cff800080",
        ["Blue"] = "|cff0000FF",
        ["Gray"] = "|cff808080",
        ["Black"] = "|cff000000",
        
        ["Druid"] = "|cffff7d0a",
        ["Cazador"] = "|cffabd473",
        ["Mage"] = "|cff69ccf0",
        ["Paladin"] = "|cfff58cba",
        ["Sacerdote"] = "|cffffffff",
        ["Granuja"] = "|cfffff569",
        ["Shaman"] = "|cff2459ff",
        ["Warlock"] = "|cff9482ca",
        ["Guerrero"] = "|cffc79c6e",
    },
}
------------------------------------------
-- COLOR LIST
------------------------------------------
-- To add one of these colors below, simply copy the line and paste it into the table above
-- as if you were adding you're own color as instructed above.
--[[
["Steel Blue"] = "|cff4682B4",
["Royal Blue"] = "|cff041690",
["Cornflower Blue"] = "|cff6495ED",
["Light Steel Blue"] = "|cffB0C4DE",
["Medium Slate Blue"] = "|cff7B68EE",
["Slate Blue"] = "|cff6A5ACD",
["Dark Slate Blue"] = "|cff483D8B",
["Midnight Blue"] = "|cff191970",
["Navy"] = "|cff000080",
["Dark Blue"] = "|cff00008B",
["Medium Blue"] = "|cff0000CD",
["Dodger Blue"] = "|cff1E90FF",
["Deep Sky Blue"] = "|cff00BFFF",
["Light Sky Blue"] = "|cff87CEFA",
["Sky Blue"] = "|cff87CEEB",
["Light Blue"] = "|cffADD8E6",
["Powder Blue"] = "|cffB0E0E6",
["Azure"] = "|cffF0FFFF",
["Light Cyan"] = "|cffE0FFFF",
["Pale Turquoise"] = "|cffAFEEEE",
["Medium Turquoise"] = "|cff48D1CC",
["Light Sea Green"] = "|cff20B2AA",
["Dark Cyan"] = "|cff008B8B",
["Teal"] = "|cff008080",
["Cadet Blue"] = "|cff5F9EA0",
["Dark Turquoise"] = "|cff00CED1",
["Aqua"] = "|cff00FFFF",
["Cyan"] = "|cff00FFFF",
["Turquoise"] = "|cff40E0D0",
["Aquamarine"] = "|cff7FFFD4",
["Medium Aquamarine"] = "|cff66CDAA",
["Dark Sea Green"] = "|cff8FBC8F",
["Medium Sea Green"] = "|cff3CB371",
["Sea Green"] = "|cff2E8B57",
["Dark Green"] = "|cff006400",
["Forest Green"] = "|cff228B22",
["Lime Green"] = "|cff32CD32",
["Lime"] = "|cff00FF00",
["Chartreuse"] = "|cff7FFF00",
["Lawn Green"] = "|cff7CFC00",
["Green Yellow"] = "|cffADFF2F",
["Yellow Green"] = "|cff9ACD32",
["Pale Green"] = "|cff98FB98",
["Light Green"] = "|cff90EE90",
["Spring Green"] = "|cff00FF7F",
["Medium Spring Green"] = "|cff00FA9A",
["Dark Olive Green"] = "|cff556B2F",
["Olive Drab"] = "|cff6B8E23",
["Olive"] = "|cff808000",
["Dark Khaki"] = "|cffBDB76B",
["Dark Goldenrod"] = "|cffB8860B",
["Goldenrod"] = "|cffDAA520",
["Khaki"] = "|cffF0E68C",
["Pale Goldenrod"] = "|cffEEE8AA",
["Blanched Almond"] = "|cffFFEBCD",
["Moccasin"] = "|cffFFE4B5",
["Wheat"] = "|cffF5DEB3",
["Navajo White"] = "|cffFFDEAD",
["Burlywood"] = "|cffDEB887",
["Tan"] = "|cffD2B48C",
["Rosy Brown"] = "|cffBC8F8F",
["Sienna"] = "|cffA0522D",
["Saddle Brown"] = "|cff8B4513",
["Chocolate"] = "|cffD2691E",
["Peru"] = "|cffCD853F",
["Sandy Brown"] = "|cffF4A460",
["Dark red"] = "|cff8B0000",
["Maroon"] = "|cff800000",
["Firebrick"] = "|cffB22222",
["Indian Red"] = "|cffCD5C5C",
["Light Coral"] = "|cffF08080",
["Salmon"] = "|cffFA8072",
["Dark Salmon"] = "|cffE9967A",
["Light Salmon"] = "|cffFFA07A",
["Coral"] = "|cffFF7F50",
["Tomato"] = "|cffFF6347",
["Dark Orange"] = "|cffFF8C00",
["Orange Red"] = "|cffFF4500",
["Crimson"] = "|cffDC143C",
["Deep Pink"] = "|cffFF1493",
["Fuchsia"] = "|cffFF00FF",
["Magenta"] = "|cffFF00FF",
["Hot Pink"] = "|cffFF69B4",
["Light Pink"] = "|cffFFB6C1",
["Pale Violet Red"] = "|cffDB7093",
["Medium Violet Red"] = "|cffC71585",
["Dark Magenta"] = "|cff8B008B",
["Medium Purple"] = "|cff9370DB",
["Blue Violet"] = "|cff8A2BE2",
["Indigo"] = "|cff4B0082",
["Dark Violet"] = "|cff9400D3",
["Dark Orchid"] = "|cff9932CC",
["Medium Orchid"] = "|cffBA55D3",
["Orchid"] = "|cffDA70D6",
["Violet"] = "|cffEE82EE",
["Plum"] = "|cffDDA0DD",
["Thistle"] = "|cffD8BFD8",
["Lavender"] = "|cffE6E6FA",
["Ghost White"] = "|cffF8F8FF",
["Alice Blue"] = "|cffF0F8FF",
["Mintcream"] = "|cffF5FFFA",
["Honeydew"] = "|cffF0FFF0",
["Light Goldenrod Yellow"] = "|cffFAFAD2",
["Lemon Chiffon"] = "|cffFFFACD",
["Cornsilk"] = "|cffFFF8DC",
["Light Yellow"] = "|cffFFFFE0",
["Ivory"] = "|cffFFFFF0",
["Floral White"] = "|cffFFFAF0",
["Linen"] = "|cffFAF0E6",
["Old Lace"] = "|cffFDF5E6",
["Antique White"] = "|cffFAEBD7",
["Bisque"] = "|cffFFE4C4",
["Peachpuff"] = "|cffFFDAB9",
["Papaya Whip"] = "|cffFFEFD5",
["Beige"] = "|cffF5F5DC",
["Seashell"] = "|cffFFF5EE",
["Lavender Blush"] = "|cffFFF0F5",
["Misty Rose"] = "|cffFFE4E1",
["Snow"] = "|cffFFFAFA",
["White Smoke"] = "|cffF5F5F5",
["Gainsboro"] = "|cffDCDCDC",
["Light Gray"] = "|cffD3D3D3",
["Silver"] = "|cffC0C0C0",
["Dark Gray"] = "|cffA9A9A9",
["Light Slate Gray"] = "|cff778899",
["Slate Gray"] = "|cff708090",
["Dim Gray"] = "|cff696969",
["Dark Slate Gray"] = "|cff2F4F4F",
]]