
function Skinner:Dewdrop()

	self:SecureHook(AceLibrary("Dewdrop-2.0"), "Open", function(parent, ...)
--		self:Debug("DewdropOpen: [%s]", parent)
		self:Skin_Dewdrop()
		end)
	
	self:Skin_Dewdrop()
	
end

local dewdropsSkinned = {}

function Skinner:Skin_Dewdrop()
	if not self.db.profile.Tooltips.skin then return end

--	self:Debug("Skin_Dewdrop")

	local fh = nil

	local i = 1
	while _G["Dewdrop20Level"..i] do
--		self:Debug("Dewdrop20Level"..i)
		local frame = _G["Dewdrop20Level"..i]
		if not dewdropsSkinned["Dewdrop20Level"..i] then
			dewdropsSkinned["Dewdrop20Level"..i] = true
			self:applySkin(frame)
			-- hook these to stop the Backdrop colours from being changed 
			self:Hook(frame, "SetBackdropColor", function(r, g, b, a) end, true)
			self:Hook(frame, "SetBackdropBorderColor", function(r, g, b, a) end, true)
			-- hide the backdrop frame
			self:getChild(frame, 1):Hide()
		end
		if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
			fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
		end
		if self.db.profile.Gradient.invert then
			frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 4, 4)
			if fh then frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", -4, -(fh - 4))
			else frame.tfade:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -4, -4) end
		else
			frame.tfade:SetPoint("TOPLEFT", frame, "TOPLEFT", 4, -4)
			if fh then frame.tfade:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", -4, -(fh - 4))
			else frame.tfade:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -4, 4) end
		end
		i = i + 1
	end
	
	-- hook the OnEnter script for the buttons and use that to skin from
	local i = 1
	while _G["Dewdrop20Button"..i] do
--		self:Debug("DB found: [%s]", i)
		if not self:IsHooked(_G["Dewdrop20Button"..i], "OnEnter") then
			self:HookScript(_G["Dewdrop20Button"..i], "OnEnter", function(this, ...)
				self.hooks[this].OnEnter(this, ...)
				if not this.disabled then
					if this.hasArrow then
-- 						self:Debug("DB has Arrow: [%s]", this:GetName())
						self:Skin_Dewdrop()
					end
				end
				end)
		end
		i = i + 1
	end
	
	-- Check to see if the SliderFrame and/or EditBox need to be skinned
	-- if so then check to see if they have been created yet
	-- if they have then skin them
	if not dewdropsSkinned["sliderFrame"] then
		local sf = self:findFrame(170, 100, {"Slider", "EditBox"})
		if sf then
			self:skinEditBox(sf.currentText, {9})
			-- Make it wider to display 4 digits
			sf.currentText:ClearAllPoints()
			sf.currentText:SetPoint("RIGHT", sf, "RIGHT", -12, 0)
			sf.currentText:SetPoint("LEFT", sf.slider, "RIGHT", 8, 0)
			self:applySkin(sf)
			dewdropsSkinned["sliderFrame"] = true
		end
	end
	if not dewdropsSkinned["editBoxFrame"] then
		local eb = self:findFrame(40, 200, {"EditBox"})
		if eb then
			self:skinEditBox(eb.editBox, {9})
			eb.editBox:SetWidth(180)
			self:applySkin(eb)
			dewdropsSkinned["editBoxFrame"] = true
		end
	end
	
end
