
function Skinner:FBagOfHolding()
	if not self.db.profile.ContainerFrames.skin then return end

	if FBoH.bagViews then
		for _, v in pairs(FBoH.bagViews) do
			self:skinFBoHBags(v)
		end
	end
	
-->>-- Configure Frame
	self:keepFontStrings(FBoH_Configure)
	self:moveObject(FBoH_Configure_CloseButton, "-", 3, nil, nil)
	self:skinEditBox(FBoH_Configure_Base_NameEdit, {9})
	self:moveObject(FBoH_Configure_Base_NameEdit, nil, nil, "+", 5)
	for _, v in pairs({ "_Left", "_Right" }) do
		for i = 1, 2 do
			local cframe = "FBoH_Configure_Frame"..i..v
			local frameObj = _G[cframe]
			local scrollObj = _G[cframe.."_Scroll"]
			self:keepFontStrings(frameObj)
			self:removeRegions(scrollObj)
			self:skinScrollBar(scrollObj)
			self:applySkin(frameObj)
		end
	end
	self:applySkin(FBoH_Configure)
-->>-- Configure Tabs	
	for i = 1, 2 do
		local tabObj = _G["FBoH_ConfigureTab"..i]
		self:keepRegions(tabObj, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then 
			self:applySkin(tabObj, nil, 0, 1)
			if i == 1 then self:setActiveTab(tabObj)
			else self:setInactiveTab(tabObj) end
		else 
			self:applySkin(tabObj)
		end
		if i == 1 then
			self:moveObject(tabObj, "-", 15, "-", 1)
		else
			self:moveObject(tabObj, "+", 13, nil, nil)
		end
	end
	
	-- hook this to manage the tabs
	if self.db.profile.TexturedTab then 
		self:SecureHook(FBoH_Configure, "ShowTab", function(this, tabID)
--			self:Debug("FBoH_C_ST:[%s, %s]", this, tabID)
			for i = 1, 2 do
				local tabObj = _G["FBoH_ConfigureTab"..i]
				if i == tabID then self:setActiveTab(tabObj)
				else self:setInactiveTab(tabObj) end
			end
			end)
	end
	
end

function Skinner:skinFBoHBags(obj)
--	self:Debug("skinFBoHBags:[%s, %s]", obj, obj.view:GetName())
	
-->>-- Frame	
	local bfObj = obj.view
	local bfName = bfObj:GetName()
	local bfIF = _G[bfName.."_ItemsFrame"]
	local bfILSF = _G[bfName.."_ItemListScrollFrame_Scroll"]
	local bfIGSF = _G[bfName.."_ItemGridScrollFrame_Scroll"]
	local bfSearch = _G[bfName.."_SearchEdit"]
	if bfObj and not bfObj.skinned then
		self:skinEditBox(bfSearch, {9})
		self:moveObject(bfSearch, nil, nil, "+", 5)
		self:applySkin(bfIF)
		self:removeRegions(bfILSF)
		self:skinScrollBar(bfILSF)
		self:removeRegions(bfIGSF)
		self:skinScrollBar(bfIGSF)
		self:applySkin(bfObj)
		bfObj.skinned = true
	end
-->>-- Tabs
	for i, _ in ipairs(obj.viewDef.tabs) do
		local tabObj = obj.tabData[i].button
		if tabObj and not tabObj.skinned then
			self:keepRegions(tabObj, {4, 5}) -- N.B. region 4 is the Text, 5 is the highlight
			if self.db.profile.TexturedTab then 
				self:applySkin(tabObj, nil, 0, 1)
				if i == obj.viewDef.activeTab then self:setActiveTab(tabObj)
				else self:setInactiveTab(tabObj) end
			else self:applySkin(tabObj) end
			if i == 1 then self:moveObject(tabObj, nil, nil, "-", 4)
			else self:moveObject(tabObj, "-", 6, nil, nil) end
			self:moveObject(self:getRegion(tabObj, 4), nil, nil, "+", 5)
			self:moveObject(self:getRegion(tabObj, 5), "+", 5, "+", 7)
			tabObj.skinned = true
			-- hook this to handle the resizing of the tab highlight width
			self:SecureHook(tabObj, "UpdateTabModel", function(this, model)
--				self:Debug("FBoH_VTT_UTM:[%s, %s]", this, model)
				self:getRegion(this, 5):SetWidth(this:GetWidth() - 10) -- shrink highlight
				end)
		end
	end
	if self.db.profile.TexturedTab then 
		self:SecureHook(obj, "SelectTab", function(this, tabIndex)
--			self:Debug("FBoH_VM.p:ST:[%s, %s]", this, tabIndex)
			for i, _ in ipairs(this.viewDef.tabs) do
				local tabObj = this.tabData[i].button
				if i == tabIndex then self:setActiveTab(tabObj)
				else self:setInactiveTab(tabObj) end
				if i == 1 then self:moveObject(tabObj, nil, nil, "-", 4)
				else self:moveObject(tabObj, "-", 6, nil, nil) end
			end
			end)
	end
	
end

