
function Skinner:GuildAds()

	-- hook these so that we know when to skin the frames
	self:SecureHook(GuildAds, "ToggleMainWindow", function()
		self:skinGuildAdsMain()
		self:Unhook(GuildAds, "ToggleMainWindow")
		end)
			
	self:SecureHook(GuildAds, "ToggleOptionsWindow", function()
		self:skinGuildAdsOptions()
		self:Unhook(GuildAds, "ToggleOptionsWindow")
		end)

	if self.db.profile.TexturedTab then
		-- hook these to manage the tabs
		self:SecureHook(GuildAdsWindow, "SelectTab", function(this, tab)
			self:setActiveTab(tab)
			end)
		self:SecureHook(GuildAdsWindow, "DeselectTab", function(this, tab)
			self:setInactiveTab(tab)
			end)
	end

end

function Skinner:skinGuildAdsMain()

-->>-- Main Frame
	self:moveObject(GuildAdsText, nil, nil, "+", 14)
	self:moveObject(GuildAdsVersion, nil, nil, "+", 14)
	self:moveObject(GuildAdsCloseButton, "-", 2, "+", 12)
	self:keepFontStrings(GuildAdsMainWindowFrame)
	self:applySkin(GuildAdsMainWindowFrame)
	
-->>-- Trade Frame
	if GuildAdsTradeFrame then
		-->>-- Main Frame
		-- tabs
		self:skinFFToggleTabs("GuildAds_MyTab", 4)
		-- sort headers
		for i = 1, 7 do
			self:keepRegions(_G["GuildAdsTradeColumnHeader"..i], {4, 5}) -- N.B. region 4 is the text, 5 is the arrow
			self:applySkin(_G["GuildAdsTradeColumnHeader"..i])
		end
		self:removeRegions(GuildAdsGlobalAdScrollFrame)
		self:skinScrollBar(GuildAdsGlobalAdScrollFrame)
		self:keepRegions(GuildAdsTradeTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then
			self:applySkin(GuildAdsTradeTab, nil, 0, 1)
			self:setActiveTab(GuildAdsTradeTab)
		else self:applySkin(GuildAdsTradeTab) end
		self:moveObject(GuildAdsTradeTab, nil, nil, "+", 18)
		-->>-- MyAds subFrame
		-- sort headers
		for i = 1, 6 do
			self:keepRegions(_G["GuildAdsMyAdsColumnHeader"..i], {4, 5}) -- N.B. region 4 is the text, 5 is the arrow
			self:applySkin(_G["GuildAdsMyAdsColumnHeader"..i])
		end
		self:removeRegions(GuildAdsMyAdScrollFrame)
		self:skinScrollBar(GuildAdsMyAdScrollFrame)
		self:skinEditBox(GuildAdsEditBox)
		self:skinEditBox(GuildAdsEditCount, {6})
		-->>-- Trade Filter Frame
		self:keepFontStrings(GuildAdsTradeFilterFrame)
		self:moveObject(GuildAdsTradeFilterFrame, nil, nil, "-", 2)
		self:applySkin(GuildAdsTradeFilterFrame)
		-- filters
		for i = 1, 15 do
			self:keepRegions(_G["FilterTradeButton"..i], {3, 4}) -- N.B. region 3 is the highlight, 4 is the text
			self:storeAndSkin(ftype, _G["FilterTradeButton"..i])
		end
		self:removeRegions(BrowseFilterTradeScrollFrame)
		self:skinScrollBar(BrowseFilterTradeScrollFrame)
		self:skinEditBox(GuildAds_Filter_BrowseName, {9})
		-- hide filter texture when filter is clicked
		self:SecureHook(GuildAdsTrade.filterClass, "filterButtonSetType", function(button, ...)
		    _G[button:GetName().."NormalTexture"]:SetAlpha(0)
		end)		
		self:skinDropDown(GuildAds_Filter_ZoneDropDown)
		self:skinDropDown(GuildAdsTradeContextMenu)
	end

-->>-- Faction Frame	
	for	i = 1, 19 do
		local gaRB = _G["GuildAdsReputationBar"..i]
		self:keepFontStrings(gaRB)
		self:glazeStatusBar(gaRB, 0)
	end
	self:removeRegions(GuildAdsReputationListScrollFrame)
	self:skinScrollBar(GuildAdsReputationListScrollFrame)
	self:moveObject(GuildAdsFactionNoneButton, nil, nil, "+", 10)
	self:applySkin(GuildAdsFactionOptionsFrame)
	self:keepRegions(GuildAdsFactionTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	if self.db.profile.TexturedTab then
		self:applySkin(GuildAdsFactionTab, nil, 0, 1)
		self:setInactiveTab(GuildAdsFactionTab)
	else self:applySkin(GuildAdsFactionTab) end
	self:moveObject(GuildAdsFactionTab, "+", 4, nil, nil)

-->>-- Skill Frame
	-- tabs
	self:skinFFToggleTabs("GuildAds_MySkillTab", 2)
	self:removeRegions(GuildAdsSkillAdScrollFrame)
	self:skinScrollBar(GuildAdsSkillAdScrollFrame)
	for i = 1, 21 do
		local gaSABSB = _G["GuildAdsSkillAdButton"..i.."SkillBar"]
		self:glazeStatusBar(gaSABSB, 0)
		local gaSABSBB = _G["GuildAdsSkillAdButton"..i.."SkillBarBorder"]
		gaSABSBB:Hide()
	end
	self:keepRegions(GuildAdsSkillTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	if self.db.profile.TexturedTab then
		self:applySkin(GuildAdsSkillTab, nil, 0, 1)
		self:setInactiveTab(GuildAdsSkillTab)
	else self:applySkin(GuildAdsSkillTab) end
	self:moveObject(GuildAdsSkillTab, "+", 4, nil, nil)

-->>-- Guild Frame
	self:skinDropDown(GuildAds_Filter_ClassDropDown)
	-- sort headers
	for i = 1, 6 do
		self:keepRegions(_G["GuildAdsGuildColumnHeader"..i], {4, 5}) -- N.B. region 4 is the text, 5 is the arrow
		self:applySkin(_G["GuildAdsGuildColumnHeader"..i])
	end
	self:removeRegions(GuildAdsPeopleGlobalAdScrollFrame)
	self:skinScrollBar(GuildAdsPeopleGlobalAdScrollFrame)
	self:keepRegions(GuildAdsGuildTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	if self.db.profile.TexturedTab then
		self:applySkin(GuildAdsGuildTab, nil, 0, 1)
		self:setInactiveTab(GuildAdsGuildTab)
	else self:applySkin(GuildAdsGuildTab) end
	self:moveObject(GuildAdsGuildTab, "+", 4, nil, nil)

-->>-- Inspect Window Frame
	self:keepFontStrings(GuildAdsInspectWindowFrame)
	self:moveObject(GuildAdsInspectWindowFrame, "-", 8, "+", 35)
	self:applySkin(GuildAdsInspectWindowFrame)
	-->>-- Inventory Frame
	self:moveObject(GuildAdsInspectHeadSlot, "+", 40, "-", 13)
	self:moveObject(GuildAdsInspectHandsSlot, "+", 44, "-", 13)
	self:moveObject(GuildAdsInspectMainHandSlot, "+", 42, "-", 40)
	self:keepRegions(GuildAdsInventoryTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	if self.db.profile.TexturedTab then
		self:applySkin(GuildAdsInventoryTab, nil, 0, 1)
		self:setActiveTab(GuildAdsInventoryTab)
	else self:applySkin(GuildAdsInventoryTab) end
	self:moveObject(GuildAdsInventoryTab, nil, nil, "+", 3)
	-->>-- Talent Frame
	self:keepRegions(GuildAdsTalentFrame, {6, 7, 8, 9, 10, 14, 15, 16}) -- N.B. 6-9 are the background picture, 10, 14-16 are text regions
	self:moveObject(GuildAdsTalentFrame, nil, nil, "+", 20)
	GuildAdsTalentFrameTitleText:Hide()
	GuildAdsTalentFrameCloseButton:Hide()
	self:removeRegions(GuildAdsTalentFrameScrollFrame)
	self:skinScrollBar(GuildAdsTalentFrameScrollFrame)
	for i = 1, 5 do
		local tft = _G["GuildAdsTalentFrameTab"..i]
		self:keepFontStrings(tft)
		if i ~= 1 then self:moveObject(tft, "+", 12, nil, nil) end
		self:applySkin(tft)
	end
	self:keepRegions(GuildAdsTalentTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	if self.db.profile.TexturedTab then
		self:applySkin(GuildAdsTalentTab, nil, 0, 1)
		self:setInactiveTab(GuildAdsTalentTab)
	else self:applySkin(GuildAdsTalentTab) end
	self:moveObject(GuildAdsTalentTab, "+", 4, nil, nil)

-->>-- Tooltip
	if GuildAdsGameTooltip then
		if self.db.profile.Tooltips.skin then
			if self.db.profile.Tooltips.style == 3 then GuildAdsGameTooltip:SetBackdrop(backdrop) end
			self:skinTooltip(GuildAdsGameTooltip)
		end
	end
	
end

function Skinner:skinGuildAdsOptions()

-->>-- Options Frame
	if GuildAdsOptionsWindowFrame then
		GuildAdsOptionsWindowHeader:Hide()
		self:moveObject(GuildAdsOptionsWindowHeader, nil, nil, "-", 6)
		self:applySkin(GuildAdsOptionsWindowFrame)
	end

-->>-- Channel Options Frame
	if GuildAdsChannelOptionsFrame then
		self:skinEditBox(GuildAds_ChannelAliasEditBox, {15})
		self:skinEditBox(GuildAds_ChannelCommandEditBox, {15})
		self:skinEditBox(GuildAds_ChannelEditBox, {15})
		self:skinEditBox(GuildAds_ChannelPasswordEditBox, {15})
		self:applySkin(GuildAdsChannelOptionsFrame)
		self:keepRegions(GuildAdsChannelOptionsTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then
			self:applySkin(GuildAdsChannelOptionsTab, nil, 0, 1)
			self:setActiveTab(GuildAdsChannelOptionsTab)
		else self:applySkin(GuildAdsChannelOptionsTab) end
		self:moveObject(GuildAdsChannelOptionsTab, nil, nil, "+", 1)
	end

-->>-- Trade Options Frame
	if GuildAdsTradeOptionsFrame then
		self:applySkin(GuildAdsTradeOptionsFrame)
		self:keepRegions(GuildAdsTradeOptionsTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then
			self:applySkin(GuildAdsTradeOptionsTab, nil, 0, 1)
			self:setInactiveTab(GuildAdsTradeOptionsTab)
		else self:applySkin(GuildAdsTradeOptionsTab) end
		self:moveObject(GuildAdsTradeOptionsTab, "+", 6, nil, nil)
	end

-->>-- MinimapButton Options Frame
	if GuildAdsMinimapButtonOptions then
		self:applySkin(GuildAdsMinimapButtonOptions)
		self:keepRegions(GuildAdsMinimapButtonTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then
			self:applySkin(GuildAdsMinimapButtonTab, nil, 0, 1)
			self:setInactiveTab(GuildAdsMinimapButtonTab)
		else self:applySkin(GuildAdsMinimapButtonTab) end
		self:moveObject(GuildAdsMinimapButtonTab, "+", 6, nil, nil)
	end

-->>-- Admin Options Frame	
	if GuildAdsAdminOptionsFrame then
		self:applySkin(GuildAdsAdminOptionsFrame)
		self:keepRegions(GuildAdsAdminOptionsTab, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then
			self:applySkin(GuildAdsAdminOptionsTab, nil, 0, 1)
			self:setInactiveTab(GuildAdsAdminOptionsTab)
		else self:applySkin(GuildAdsAdminOptionsTab) end
		self:moveObject(GuildAdsAdminOptionsTab, "+", 6, nil, nil)
	end
	
end
