
function Skinner:OptionHouse(optHouse, ...)
	
--	self:Debug("OptionHouse: [%s, %s, %s, %s, %s]", optHouse, select(1, ...) or "nil", select(2, ...) or "nil", select(3, ...) or "nil", select(4, ...) or "nil")
	
	--	move the Addon's frame down
	local ohAFrame = optHouse:GetFrame("addon")
	if ohAFrame and ohAFrame.shownFrame then self:OHmoveFrame(ohAFrame.shownFrame) end
	
	if optHouse.skinned then return end

	--	check to see if the frames have been created yet	
	local ohFrame = optHouse:GetFrame("main")
	if not ohFrame then return end
	
--	self:Debug("OH Main Frame: [%s]", ohFrame)
	ohFrame:SetHeight(ohFrame:GetHeight() * FyMult + 10)
	self:keepFontStrings(ohFrame)
	-- move the title
	self:getRegion(ohFrame, 2):SetPoint("TOP", 0, -6)
	-- move the close button
	for k, v in pairs({ ohFrame:GetChildren() }) do
		if v:GetObjectType() == "Button"
		and math.floor(v:GetWidth()) == 32
		and math.floor(v:GetHeight()) == 32 then
			v:SetPoint("TOPRIGHT", 0, 0)
			break
		end
	end
	self:applySkin(ohFrame)

	-- Tabs
	for i = 1, #ohFrame.tabs do
		local tabName = ohFrame.tabs[i]
--		self:Debug("OH Tab: [%s, %s]", i, tabName:GetWidth())
		self:keepRegions(tabName, {1, 2}) -- N.B. region 1 is the Text, 2 is the highlight
		if self.db.profile.TexturedTab then self:applySkin(tabName, nil, 0, 1)
		else self:applySkin(tabName) end
		tabName:ClearAllPoints()
		if i == 1 then
			self:setActiveTab(tabName)
			tabName:SetPoint("TOPLEFT", ohFrame, "BOTTOMLEFT", 15, 7)
		else 
			self:setInactiveTab(tabName)
			tabName:SetPoint("TOPLEFT", ohFrame.tabs[i - 1], "TOPRIGHT", -4, 0)
		end
		self:Hook(tabName, "SetPoint", function(this, ...) end, true)
	end
	
	-- Hook this to manage the Sub Frames
	self:SecureHook(optHouse, "RegisterFrame", function(this, type, frame)
--		self:Debug("OH_RF: [%s, %s]", type, frame)
		self:keepFontStrings(frame.scroll)
		frame.scroll.bar:GetThumbTexture():SetAlpha(1)
		self:skinUsingBD2(frame.scroll.bar)
		frame.scroll.bar:ClearAllPoints()
		frame.scroll.bar:SetPoint("TOPLEFT", frame.scroll, "TOPRIGHT", 6, 12)
		frame.scroll.bar:SetPoint("BOTTOMLEFT", frame.scroll, "BOTTOMRIGHT", 6, -10)
		self:moveObject(frame.sortButtons[1], nil, nil, "+", 50, frame)
		if type == "manage" then
			self:moveObject(frame.sortButtons[2], nil, nil, "+", 50, frame)
			self:moveObject(frame.sortButtons[3], nil, nil, "+", 50, frame)
		end
	 	self:skinEditBox(frame.search, {9})
		if self.db.profile.TexturedTab then
			self:SecureHook(frame, "Show", function(this, ...)
				for i = 1, #ohFrame.tabs do
					local tabName = ohFrame.tabs[i]
					self:setInactiveTab(tabName)
					if i == optHouse:GetFrame("main").selectedTab then self:setActiveTab(tabName) end
				end
				end)
		end
		end)
	
--	Addon Frame
	local ohAFrame = optHouse:GetFrame("addon")
--	self:Debug("OH Addon Frame: [%s]", ohAFrame)
	local sf = ohAFrame.scroll
	self:keepFontStrings(sf)
	self:skinUsingBD2(sf.bar)
	self:moveObject(sf, nil, nil, "+", 45, ohAFrame)
	local thumb = sf.bar:GetThumbTexture()
	thumb:SetAlpha(1)
 	self:skinEditBox(ohAFrame.search, {9})
	-- hook Addons button OnClick
 	for i = 1, 15 do
 		local ohSFbutton = ohAFrame.buttons[i]
 		if i == 1 then self:moveObject(ohSFbutton, nil, nil, "+", 50, ohAFrame) end
 		self:keepRegions(ohSFbutton, {2, 4}) -- N.B. region 2 is the Text, 4 is the highlight
 		local ohSFBGNT = ohSFbutton:GetNormalTexture()
 		self:Hook(ohSFBGNT, "SetAlpha", function(...) end, true) -- stop the textures being shown
		-- hook this to manage the sub fields	
		-- N.B. Don't unhook them as they are reallocated as required
		self:HookScript(ohSFbutton, "OnClick", function(this, ...)
			self.hooks[this].OnClick(this, ...)
--			self:Debug("OH_AF_OC: [%s, %s, %s, %s]", this, this.catText, this.type, this.data)
			if this.data and this.data.frame then self:OHmoveFrame(this.data.frame) end
			if this.catText == "OptionHouse" and not this.data.skinned then
				self:skinEditBox(OHConfigUIPerfSize, {9})
				self:moveObject(OHConfigUIPerfSize, "-", 8, "+", 4, this.data.frame)
				self:skinEditBox(OHConfigUIManageSize, {9})
				self:moveObject(OHConfigUIManageSize, "-", 8, nil, nil, this.data.frame)
				self:keepFontStrings(OHConfigUIDepMode)
				self:keepFontStrings(OHConfigUIChildMode)
				this.data.skinned = true
			end
			end)
 	end
	self:SecureHook(ohAFrame, "Show", function(this, ...)
		for i = 1, #ohFrame.tabs do
			local tabName = ohFrame.tabs[i]
			self:setInactiveTab(tabName)
			if i == optHouse:GetFrame("main").selectedTab then self:setActiveTab(tabName) end
		end
		end)
	
	optHouse.skinned = true

end

function Skinner:OHmoveFrame(frame)
--	self:Debug("OHmF: [%s, %s]", frame:GetObjectType(), frame:GetName())
	
	if frame:GetObjectType() == "ScrollFrame" then
		if not frame.sbskinned then
			frame:SetPoint("TOPLEFT", frame:GetParent(), "TOPLEFT", 190, -53)
			self:keepFontStrings(frame)
			self:skinScrollBar(frame)
			frame.sbskinned = true
		end
	elseif not frame.moved then
		self:moveObject(frame, nil, nil, "+", 50, frame:GetParent())
		frame.moved = true
	end
 	
end
