
function Skinner:Tablet()

	self:SecureHook(AceLibrary("Tablet-2.0"), "Open", function(tablet, parent)
--		self:Debug("TabletOpen: [%s, %s]", tablet, parent)
		self:skinTablet()
		end)
	self:SecureHook(AceLibrary("Tablet-2.0"), "Detach", function(tablet, parent)
--		self:Debug("TabletDetach: [%s, %s]", tablet, parent)
		self:skinTablet()
		end)

	self:skinTablet()

end

function Skinner:skinTablet()
	if not self.db.profile.Tooltips.skin then return end
	
	if not self.db.profile.TrackerFrame then 
		--	Check for the QuestsFu_Tracker
		local qftinfo = AceLibrary("Tablet-2.0").registry['QuestsFu_Tracker']
		if qftinfo and qftinfo.tooltip then
			local tt = qftinfo.tooltip
	--		self:Debug("ST: [%s, %s]", tt, tt:GetName())
			tt:SetBackdrop(nil)
			tt.skinned = true
			tt.noFH = true
		end
	end
	
	if Tablet20Frame then
		local frame = Tablet20Frame
		if not frame.skinned then
			-- self:Debug("Tablet20Frame")
			self:applySkin(frame)
			frame.skinned = true
			-- hook these to stop the Backdrop colours from being changed 
			self:Hook(frame, "SetBackdropColor", function(this, ...) end, true)
			self:Hook(frame, "SetBackdropBorderColor", function(this, ...) end, true)
			end
		self:fadeTablet(frame)
	end
	
	local i = 1
	while _G["Tablet20DetachedFrame"..i] do
		local frame = _G["Tablet20DetachedFrame"..i]
		if not frame.skinned then
			-- self:Debug("DetachedFrame: [%s, %s]", frame:GetName(), frame:GetParent():GetName() )
			self:applySkin(frame)
			frame.skinned = true
			-- hook these to stop the Backdrop colours from being changed 
			self:Hook(frame, "SetBackdropColor", function(this, ...) end, true)
			self:Hook(frame, "SetBackdropBorderColor", function(this, ...) end, true)
		end
		if not frame.noFH then
			self:fadeTablet(frame)
		end
		i = i + 1
	end
	
end

function Skinner:fadeTablet(frame)

	local fh = nil
	
	if self.db.profile.FadeHeight.enable and self.db.profile.FadeHeight.force then
		fh = self.db.profile.FadeHeight.value <= math.ceil(frame:GetHeight()) and self.db.profile.FadeHeight.value or math.ceil(frame:GetHeight())
	end
	if self.db.profile.Gradient.invert then
		frame.tfade:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT", 4, 4)
		if fh then frame.tfade:SetPoint("TOPRIGHT", frame, "BOTTOMRIGHT", -4, -(fh - 4))
		else frame.tfade:SetPoint("TOPRIGHT", frame, "TOPRIGHT", -4, -4) end
	else
		frame.tfade:SetPoint("TOPLEFT", frame, "TOPLEFT", 4, -4)
		if fh then frame.tfade:SetPoint("BOTTOMRIGHT", frame, "TOPRIGHT", -4, -(fh - 4))
		else frame.tfade:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT", -4, 4) end
	end

end
