
local violationsSkinned = {}

function Skinner:Violation()

	self:SecureHook(Violation, "ToggleWindows", function(this, show)
-- 		self:Debug("V - ToggleWindows: [%s]", show)
		self:skinViolation()
		end)
	self:Hook(Violation, "OpenWindows", function(this)
-- 		self:Debug("V - OpenWindows")
		self:skinViolation()
		self.hooks[Violation].OpenWindows(this)
		end, true)
	self:SecureHook(Violation, "SetupWindows", function(this)
-- 		self:Debug("V - SetupWindows")
		self:skinViolation()
		end)
	self:SecureHook(Violation, "UpdateWindows", function(this, sameamount)
-- 		self:Debug("V- UpdateWindows: [%s]", sameamount)
		self:skinViolation()
		end)
	self:SecureHook(Violation, "DeleteWindow", function(this, window)
-- 		self:Debug("V - DeleteWindow: [%s, %s]", window, window.frame)
		violationsSkinned[window.frame] = nil
		if self:IsHooked(frame, "OnShow") then self:Unhook(frame, "OnShow") end
		if self:IsHooked(frame, "SetBackdropBorderColor") then self:Unhook(frame, "SetBackdropBorderColor") end
		end)

	self:skinViolation()

end

function Skinner:skinViolation()

	for k, Vw in ipairs( Violation.windows ) do
-- 		self:Debug("V-window: [%s]", Vw)
		if Vw then
			-- hook this to manage the statusbars
			if not self:IsHooked(Vw, "SetBar") then
				self:SecureHook(Vw, "SetBar", function(this, count, ...)
					local btn = this.currentBars[count]
-- 					self:Debug("V-statusbar: [%s, %s]", btn, btn.statusbar)
					if btn then
-- 						self:Debug("V: [%s, %s]", btn, btn:GetWidth())
						btn:ClearAllPoints()						
						if count == 1 then
							btn:SetPoint( "TOP", this.frame, "TOP", 0, -21 )
						else
							btn:SetPoint( "TOP", this.currentBars[count - 1], "BOTTOM", 0, -1 )
						end
						btn:SetPoint( "LEFT", this.frame, "LEFT", 4, 0)
						btn:SetPoint( "RIGHT", this.frame, "RIGHT", -4, 0)
					end
					end)
			end
			local frame = Vw.frame
-- 			self:Debug("V-frame: [%s, %s, %s, %s]", frame, violationsSkinned[frame], Vw.options.show, frame:IsShown())
			if Vw.options.show then
				if not violationsSkinned[frame] then
					self:VframeSkin(frame)
					-- hook this to manage the frame
					if not self:IsHooked(frame, "OnShow") then
						self:HookScript(frame, "OnShow", function(this, ...) 
-- 							self:Debug("V-frame_OnShow: [%s, %s]", this, ... or "?")
							self.hooks[this].OnShow(this, ...)
							self:VframeSkin(this)
							end)
					end
				end
			end
		end
	end
	
end

function Skinner:VframeSkin(frame)

-- 	self:Debug("VframeSkin: [%s, %s]",frame, violationsSkinned[frame])
	
	if not violationsSkinned[frame] then
		frame.header:SetWidth(frame:GetWidth() - 48)
		local _,_,_,_, yOfs = frame.header:GetPoint()
		yOfs = math.floor(yOfs)
-- 		self:Debug("V_header_GP: [%s]", yOfs)
		if yOfs == -14 then
			self:moveObject(frame.header, nil, nil, "+", 9, frame)
			self:moveObject(frame.closebutton, nil, nil, "+", 9, frame)
			self:moveObject(frame.prevbutton, nil, nil, "+", 9, frame)
			self:moveObject(frame.nextbutton, nil, nil, "+", 9, frame)
		end
		self:applySkin(frame)
		violationsSkinned[frame] = true
		-- hook this to stop the BackdropBorder colour from being changed 
		self:Hook(frame, "SetBackdropBorderColor", function(...) end, true)
	end
	
end

