local ftype = "u"

function Skinner:MenuFrames()
	if not self.db.profile.MenuFrames or self.initialized.MenuFrames then return end
	self.initialized.MenuFrames = true

	self:storeAndSkin(ftype, GameMenuFrame, true)

--	Video Options
	self:storeAndSkin(ftype, OptionsFrame, true)
	self:skinDropDown(OptionsFrameResolutionDropDown)
	self:skinDropDown(OptionsFrameRefreshDropDown)
	self:skinDropDown(OptionsFrameMultiSampleDropDown)

	self:storeAndSkin(ftype, OptionsFrameDisplay)
	self:storeAndSkin(ftype, OptionsFrameWorldAppearance)
	self:storeAndSkin(ftype, OptionsFrameBrightness)
	self:storeAndSkin(ftype, OptionsFramePixelShaders)
	self:storeAndSkin(ftype, OptionsFrameMiscellaneous)

-- 	Sound & Voice Options (Voice New 2.2)
	self:storeAndSkin(ftype, AudioOptionsFrame, true)
-->>-- Sound Options
	self:storeAndSkin(ftype, SoundOptionsFramePlayback)
	self:storeAndSkin(ftype, SoundOptionsFrameHardware)
	self:skinDropDown(SoundOptionsOutputDropDown)
	self:storeAndSkin(ftype, SoundOptionsFrameVolume)
-->>-- Voice Options
	self:skinDropDown(VoiceOptionsFrameInputDeviceDropDown)
	self:storeAndSkin(ftype, VoiceOptionsFrameTalking)
	self:skinDropDown(VoiceOptionsFrameTypeDropDown)
	self:storeAndSkin(ftype, VoiceOptionsFrameMode)
	self:skinDropDown(VoiceOptionsFrameOutputDeviceDropDown)
	self:storeAndSkin(ftype, VoiceOptionsFrameSpeaking)
-->>-- Voice Chat Button
	self:skinDropDown(MiniMapVoiceChatDropDown)
	self:storeAndSkin(ftype, VoiceChatTalkers)
-->>-- Tabs
	self:keepRegions(AudioOptionsFrameTab1, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	self:keepRegions(AudioOptionsFrameTab2, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
	self:moveObject(AudioOptionsFrameTab1, nil, nil, "-", 1)
	self:moveObject(AudioOptionsFrameTab2, "+", 12, nil, nil)
	if self.db.profile.TexturedTab then
		self:applySkin(AudioOptionsFrameTab1, nil, 0, 1)
		self:applySkin(AudioOptionsFrameTab2, nil, 0, 1)
		self:setActiveTab(AudioOptionsFrameTab1)
		self:setInactiveTab(AudioOptionsFrameTab2)
		self:SecureHook("ToggleAudioOption", function(tab)
			-- frame names are back to front in the table
			if tab == AUDIOOPTIONSFRAME_SUBFRAMES[2] then
				self:setActiveTab(AudioOptionsFrameTab1)
				self:setInactiveTab(AudioOptionsFrameTab2)
			else
				self:setActiveTab(AudioOptionsFrameTab2)
				self:setInactiveTab(AudioOptionsFrameTab1)
			end
			end)
	else
		self:storeAndSkin(ftype, AudioOptionsFrameTab1)
		self:storeAndSkin(ftype, AudioOptionsFrameTab2)
	end

-- Mac Options (New 2.2)
	if IsMacClient() then
		self:storeAndSkin(ftype, MacOptionsFrame, true)
		self:storeAndSkin(ftype, MacOptionsFrameMovieRecording)
		self:skinDropDown(MacOptionsFrameResolutionDropDown)
		self:skinDropDown(MacOptionsFrameFramerateDropDown)
		self:skinDropDown(MacOptionsFrameCodecDropDown)
		self:storeAndSkin(ftype, MacOptionsITunesRemote)
	-->>-- Movie Progress Frame
		self:glazeStatusBar(MovieProgressBar, 0)
		self:storeAndSkin(ftype, MovieProgressFrame)
		self:storeAndSkin(ftype, MacOptionsCancelFrame, true)
	end

--	Interface (changed in 2.4)
	--	InterfaceOptionsFrame
	self:removeRegions(InterfaceOptionsFrameCategoriesList)
	self:skinScrollBar(InterfaceOptionsFrameCategoriesList)
	self:storeAndSkin(ftype, InterfaceOptionsFrameCategories, nil)
	self:removeRegions(InterfaceOptionsFrameAddOnsList)
	self:skinScrollBar(InterfaceOptionsFrameAddOnsList)
	self:storeAndSkin(ftype, InterfaceOptionsFrameAddOns, nil)
	self:keepFontStrings(InterfaceOptionsFrame)
	self:storeAndSkin(ftype, InterfaceOptionsFrame, true)
	-- Tabs
	for i = 1, 2 do
		local tabName = _G["InterfaceOptionsFrameTab"..i]
		local tabNameT = _G["InterfaceOptionsFrameTab"..i.."Text"]
		local tabNameHT = _G["InterfaceOptionsFrameTab"..i.."HighlightTexture"]
		self:keepRegions(tabName, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then self:applySkin(tabName, nil, 0, 1)
		else self:storeAndSkin(ftype, tabName) end
		self:moveObject(tabNameT, nil, nil, "+", 3)
		self:moveObject(tabNameHT, "-", 5, "+", 3)
		if i == 2 then self:moveObject(tabName, "+", 14, nil, nil) end
	end
	-- Hook this to skin any Interface Option panels
	self:SecureHook("InterfaceOptionsList_DisplayFrame", function(frame)
--		self:Debug("IOL_DF: [%s, %s]", frame, frame:GetName())
		if not frame.skinned then
			for _, child in next, { frame:GetChildren() } do
				if child and self:isDropDown(child) then self:skinDropDown(child) end
			end
			self:storeAndSkin(ftype, frame)
			frame.skinned = true
		end
		end)

end

function Skinner:MacroUI()
	if not self.db.profile.MenuFrames or self.initialized.MacroUI then return end
	self.initialized.MacroUI = true

	self:keepFontStrings(MacroFrame)
	MacroFrame:SetWidth(MacroFrame:GetWidth() * FxMult)
	MacroFrame:SetHeight(MacroFrame:GetHeight() * FyMult)

	for i = 1, 2 do
		local tabName = _G["MacroFrameTab"..i]
		self:keepRegions(tabName, {7, 8}) -- N.B. region 7 is text, 8 is highlight
		self:moveObject(_G[tabName:GetName().."Text"], nil, nil, "+", 5)
		self:moveObject(_G[tabName:GetName().."HighlightTexture"], nil, nil, "+", 8)
		self:storeAndSkin(ftype, tabName)
	end

	self:moveObject(MacroFrameCloseButton, "+", 28, "+", 8)
	self:moveObject(MacroButton1, "-", 10, nil, nil)
	self:moveObject(MacroFrameSelectedMacroBackground, nil, nil, "+", 10)
	self:moveObject(MacroFrameTextBackground, "-", 10, "+", 10)
	self:moveObject(MacroFrameScrollFrame, "-", 10, nil, nil)
	self:moveObject(MacroDeleteButton, "-", 10, "-", 72)
	self:moveObject(MacroNewButton, "-", 4, "-", 6)
	self:moveObject(MacroExitButton, "-", 4, "-", 6)
	self:moveObject(MacroFrameCharLimitText, nil, nil, "-", 75)

	self:removeRegions(MacroFrameScrollFrame)
	self:skinScrollBar(MacroFrameScrollFrame)
	self:skinEditBox(MacroFrameText, nil, true)
	self:storeAndSkin(ftype, MacroFrameTextBackground)
	self:storeAndSkin(ftype, MacroFrame)

	-- Macro Popup Frame
	self:keepFontStrings(MacroPopupFrame)
	MacroPopupFrame:SetWidth(MacroPopupFrame:GetWidth() * FxMult)
	MacroPopupFrame:SetHeight(MacroPopupFrame:GetHeight() - 20) -- N.B. must be absolute not multiple
	self:moveObject(MacroPopupFrame, "+", 40, nil, nil)

	local xOfs, yOfs = 5, 15
	self:moveObject(MacroPopupEditBox, "-", xOfs, "+", yOfs)
	self:moveObject(MacroPopupScrollFrame, "+", 10, "+", yOfs)
	self:moveObject(MacroPopupButton1, "-", xOfs, "+", yOfs)
	self:moveObject(MacroPopupCancelButton, nil, nil, "-", 4)
	self:skinEditBox(MacroPopupEditBox)
	-- regions 5 & 6 are text
	self:moveObject(self:getRegion(MacroPopupFrame, 5), "-", xOfs, "+", yOfs)
	self:moveObject(self:getRegion(MacroPopupFrame, 6), "-", xOfs, "+", yOfs)
	self:removeRegions(MacroPopupScrollFrame)
	self:skinScrollBar(MacroPopupScrollFrame)
	self:storeAndSkin(ftype, MacroPopupFrame)

end

function Skinner:BindingUI()
	if not self.db.profile.MenuFrames or self.initialized.BindingUI then return end
	self.initialized.BindingUI = true

	self:keepFontStrings(KeyBindingFrame)
	KeyBindingFrame:SetWidth(KeyBindingFrame:GetWidth() * 0.95)
	-- N.B. Don't change Height

	self:moveObject(KeyBindingFrameHeaderText, nil, nil, "-", 8)
	self:moveObject(KeyBindingFrameCharacterButton, "+", 30, "+", 5)
	self:moveObject(KeyBindingFrameOutputText, nil, nil, "-", 10)
	self:moveObject(KeyBindingFrameDefaultButton, nil, nil, "-", 14)
	self:moveObject(KeyBindingFrameCancelButton, "+", 40, "-", 14)

	self:removeRegions(KeyBindingFrameScrollFrame)
	self:skinScrollBar(KeyBindingFrameScrollFrame)

	self:storeAndSkin(ftype, KeyBindingFrame)

end

function Skinner:makeModelFramesRotatable()
--[[
[12:55:21] <dreyruugr> http://ace.pastey.net/551
[12:55:42] <dreyruugr> That should do framerate independant rotation of the model, based on how much the mouse moves
[13:12:43] <dreyruugr> Gngsk: http://ace.pastey.net/552 - This doesn't work quite right, but if you work on it you'll be able to zoom in on the character's face using the y offset of the mouse

This does the trick, but it might be worth stealing chester's code from SuperInspect

]]

-- Click to drag Modelframes

	self:SecureHook("Model_RotateLeft", function(model, rotationIncrement)
		if ( not rotationIncrement ) then
			rotationIncrement = 0.03
		end
		model.rotation = model.rotation - rotationIncrement
		model:SetRotation(model.rotation)
		end)
	self:SecureHook("Model_RotateRight", function(model, rotationIncrement)
		if ( not rotationIncrement ) then
			rotationIncrement = 0.03
		end
		model.rotation = model.rotation + rotationIncrement
		model:SetRotation(model.rotation)
		end)

end

function Skinner:makeMFRotatable(frame)

	--	Don't make Model Frames Rotatable if CloseUp is loaded
	if IsAddOnLoaded("CloseUp") then return end

	--frame:EnableMouseWheel(true)
	frame:EnableMouse(true)
	frame.draggingDirection = nil
	frame.cursorPosition = { }

	if not self:IsHooked(frame, "OnUpdate") then
		self:HookScript(frame, "OnUpdate", function()
			self.hooks[frame].OnUpdate()
			if this.dragging then
				local x,y = GetCursorPosition()
				if this.cursorPosition.x > x then
					Model_RotateLeft(frame, (this.cursorPosition.x - x) * arg1)
				elseif this.cursorPosition.x < x then
					Model_RotateRight(frame, (x - this.cursorPosition.x) * arg1)
				end

				this.cursorPosition.x, this.cursorPosition.y = GetCursorPosition()
			end
		end)
		self:HookScript(frame, "OnMouseDown", function()
			self.hooks[frame].OnMouseDown()
			if arg1 == "LeftButton" then
				this.dragging = true
				this.cursorPosition.x, this.cursorPosition.y = GetCursorPosition()
			end
			end)
		self:HookScript(frame, "OnMouseUp", function()
			self.hooks[frame].OnMouseUp()
			if this.dragging then
				this.dragging = false
				this.cursorPosition.x, this.cursorPosition.y = nil
			end
			end)
	end

	--[[ MouseWheel to zoom Modelframe - in/out works, but needs to be fleshed out
	frame:SetScript("OnMouseWheel", function()
		local xPos, yPos, zPos = frame:GetPosition()
		if arg1 == 1 then
			frame:SetPosition(xPos+00.1, 0, 0)
		else
			frame:SetPosition(xPos-00.1, 0, 0)
		end
	end) ]]
end

function Skinner:BankFrame()
	if not self.db.profile.BankFrame or self.initialized.BankFrame then return end
	self.initialized.BankFrame = true

	self:keepFontStrings(BankFrame)

	BankFrame:SetWidth(BankFrame:GetWidth() * FxMult)
	BankFrame:SetHeight(BankFrame:GetHeight() * FyMult)

	self:moveObject(BankFrameTitleText, nil, nil, "-", 35)
	self:moveObject(BankCloseButton, "+", 20, "+", 6)
	self:moveObject(BankFrameItem1, "-", 10, nil, nil)
	-- regions 4 and 5 hold the slot text
	self:moveObject(self:getRegion(BankFrame, 4), "+", 10, "-", 40)
	self:moveObject(self:getRegion(BankFrame, 5), "+", 10, "-", 40)
	self:moveObject(BankFramePurchaseInfo, nil, nil, "-", 40)
	self:moveObject(BankFrameMoneyFrame, nil, nil, "_", 90)

	self:storeAndSkin(ftype, BankFrame)

end

function Skinner:MailFrame()
	if not self.db.profile.MailFrame or self.initialized.MailFrame then return end
	self.initialized.MailFrame = true

	if self.db.profile.TexturedTab then
		self:SecureHook("MailFrameTab_OnClick", function(tab)
--			self:Debug("MailFrameTab_OnClick: [%s]", tab)
--			self:Debug("MailFrameTab_OnClick#2: [%s]", PanelTemplates_GetSelectedTab(MailFrame))
			for i = 1, MailFrame.numTabs do
				local tabName = _G["MailFrameTab"..i]
				if i == MailFrame.selectedTab then
					self:setActiveTab(tabName)
				else
					self:setInactiveTab(tabName)
				end
			end
			end)
	end

	self:SecureHook("OpenMail_Update", function()
--		self:Debug("OpenMail_Update")
		self:moveObject(OpenMailAttachmentText, nil, nil, "-", 70)
		self:moveObject(OpenMailLetterButton, nil, nil, "-", 70)
		self:moveObject(OpenMailMoneyButton, nil, nil, "-", 70)
		for i = 1, ATTACHMENTS_MAX_RECEIVE do
			self:moveObject(_G["OpenMailAttachmentButton"..i], "+", 15, "-", 70)
		end
		end)

	self:keepFontStrings(MailFrame)
	MailFrame:SetWidth(MailFrame:GetWidth() * FxMult)
	MailFrame:SetHeight(MailFrame:GetHeight() * FyMult)

	self:moveObject(InboxCloseButton, "+", 28, "+", 8)

-->>--	Inbox Frame
	self:moveObject(InboxTitleText, "-", 15, "+", 12)
	self:moveObject(InboxCurrentPage, nil, nil, "+", 12)

	for i = 1, 7 do
		self:keepFontStrings(_G["MailItem"..i])
	end

	local xOfs, yOfs = 5, 20
	self:moveObject(MailItem1, "-", xOfs, "+", yOfs)
	self:moveObject(InboxPrevPageButton, "-", xOfs, "+", yOfs / 2)
	self:moveObject(InboxNextPageButton, "-", xOfs, "+", yOfs / 2)

-->>--	Send Mail Frame
	self:keepFontStrings(SendMailFrame)
	self:moveObject(SendMailTitleText, "-", 15, "+", 12)
	self:removeRegions(SendMailScrollFrame)
	self:skinScrollBar(SendMailScrollFrame)
	self:moveObject(SendMailScrollFrame, "-", 5, nil, nil)

	smFrames = { SendMailCostMoneyFrame, SendMailPackageButton, SendMailCancelButton }
	for _, v in pairs(smFrames) do
		self:moveObject(v, "-", 5, "+", 10)
	end
	self:SecureHook("SendMailFrame_Update", function()
		for i = 1, ATTACHMENTS_MAX_SEND do
			local sma = _G["SendMailAttachment"..i]
			self:moveObject(sma, "-", 10, "-", 10)
			if not sma.skinned then
				self:removeRegions(sma, {1})
				self:addSkinButton(sma, nil, nil, true)
				sma.skinned = true
			end
		end
		end)

	self:moveObject(SendMailNameEditBox, "-", 20, "+", 10)
	self:skinEditBox(SendMailNameEditBox, {6}) -- N.B. region 6 is text
	self:skinEditBox(SendMailSubjectEditBox, {6}) -- N.B. region 6 is text
	self:skinEditBox(SendMailBodyEditBox, nil, true)
	local c = self.db.profile.BodyText
	SendMailBodyEditBox:SetTextColor(c.r, c.g, c.b)

	self:skinMoneyFrame(SendMailMoney)
	self:moveObject(SendMailMoneyGold, "-", 10, nil, nil)
	self:moveObject(SendMailMoneySilver, "-", 10, nil, nil)
	self:moveObject(SendMailCancelButton, "-", 2, "-", 15)

-->>--	Open Mail Frame
	self:keepFontStrings(OpenMailFrame)
	OpenMailFrame:SetWidth(OpenMailFrame:GetWidth() * FxMult)
	OpenMailFrame:SetHeight(OpenMailFrame:GetHeight() * FyMult)
	self:moveObject(OpenMailTitleText, nil, nil, "-", 24)
	self:moveObject(OpenMailCloseButton, "+", 28, "+", 8)
	self:moveObject(OpenMailSenderLabel, "-", 5, "+", 10)
	self:moveObject(OpenMailReportSpamButton, "+", 36, "+", 12)
	self:moveObject(OpenMailSubjectLabel, "-", 5, "+", 10)
	self:moveObject(OpenMailScrollFrame, "-", 5, "+", 10)
	self:keepFontStrings(OpenMailScrollFrame)
	self:skinScrollBar(OpenMailScrollFrame)
	self:moveObject(OpenMailCancelButton, "+", 30, "-", 72)
	OpenMailBodyText:SetTextColor(BTr, BTg, BTb)
	self:storeAndSkin(ftype, OpenMailFrame)
-->>-- Invoice Frame Text fields
	OpenMailInvoiceItemLabel:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoicePurchaser:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceBuyMode:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceSalePrice:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceDeposit:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceHouseCut:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceAmountReceived:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceNotYetSent:SetTextColor(BTr, BTg, BTb)
	OpenMailInvoiceMoneyDelay:SetTextColor(BTr, BTg, BTb)

-->>--	FrameTabs
	for i = 1, MailFrame.numTabs do
		local tabName = _G["MailFrameTab"..i]
		self:keepRegions(tabName, {7, 8}) -- N.B. region 7 is text, 8 is highlight
		if self.db.profile.TexturedTab then self:applySkin(tabName, nil, 0)
		else self:storeAndSkin(ftype, tabName) end
		if i == 1 then
			self:moveObject(tabName, nil, nil, "-", 69)
			if self.db.profile.TexturedTab then self:setActiveTab(tabName) end
		else
			self:moveObject(tabName, "+", 4, nil, nil)
			if self.db.profile.TexturedTab then self:setInactiveTab(tabName) end
		end
	end

	self:storeAndSkin(ftype, MailFrame)

end

function Skinner:AuctionUI()
	if not self.db.profile.AuctionFrame or self.initialized.AuctionUI then return end
	self.initialized.AuctionUI = true

-->>-- Tabs
	if self.db.profile.TexturedTab then
		self:SecureHook("AuctionFrameTab_OnClick", function(index)
-- 	   		self:Debug("AuctionFrameTab_OnClick: [%s]", index)
			for i = 1, AuctionFrame.numTabs do
				local tabName = _G["AuctionFrameTab"..i]
				if i == AuctionFrame.selectedTab then
					self:setActiveTab(tabName)
				else
					self:setInactiveTab(tabName)
				end
			end
			end)
	end
	-- hide filter texture when filter is clicked
	self:SecureHook("FilterButton_SetType", function(button, type, text, isLast)
		_G[button:GetName().."NormalTexture"]:SetAlpha(0)
		end)

	self:keepFontStrings(AuctionFrame)
	AuctionFrame:SetHeight(AuctionFrame:GetHeight() - 6)

	self:moveObject(AuctionFrameCloseButton, "-", 4, "+", 8)

-->>--	All Tabs
	for i = 1, AuctionFrame.numTabs do
		local tabName = _G["AuctionFrameTab"..i]
		self:keepRegions(tabName, {7, 8}) -- N.B. region 7 is the Text, 8 is the highlight
		if self.db.profile.TexturedTab then self:applySkin(tabName, nil, 0)
		else self:storeAndSkin(ftype, tabName) end
		if i == 1 then
			self:moveObject(tabName, nil, nil, "-", 4)
			if self.db.profile.TexturedTab then self:setActiveTab(tabName) end
		else
			self:moveObject(tabName, "+", 3, nil, nil)
			if self.db.profile.TexturedTab then self:setInactiveTab(tabName) end
		end
	end

	self:moveObject(AuctionFrameMoneyFrame, nil, nil, "-", 6)

-->>--	Browse Frame
	self:moveObject(BrowseTitle, nil, nil, "+", 6)

	self:removeRegions(BrowseFilterScrollFrame)
	self:skinScrollBar(BrowseFilterScrollFrame)
	self:removeRegions(BrowseScrollFrame)
	self:skinScrollBar(BrowseScrollFrame)

	for i = 1, NUM_FILTERS_TO_DISPLAY do
		self:keepRegions(_G["AuctionFilterButton"..i], {3, 4}) -- N.B. region 3 is the highlight, 4 is the text
		self:storeAndSkin(ftype, _G["AuctionFilterButton"..i])
	end

	self:skinDropDown(BrowseDropDown)
	self:moveObject(BrowseDropDownName, "+", 40, nil, nil)

	for k, v in pairs({ BrowseQualitySort, BrowseLevelSort, BrowseDurationSort,	BrowseHighBidderSort, BrowseCurrentBidSort }) do
		self:keepFontStrings(v)
		self:storeAndSkin(ftype, v)
	end

	for k, v in pairs({ "BrowseName", "BrowseMinLevel", "BrowseMaxLevel" }) do
		self:skinEditBox(_G[v], {9})
		self:moveObject(_G[v], "-", 10, "+", (k ~= 3 and 3 or 0))
		_G[v]:SetWidth(_G[v]:GetWidth() + 4)
	end

	self:skinMoneyFrame(BrowseBidPrice)

-->>--	Bid Frame
	self:moveObject(BidTitle, nil, nil, "+", 6)

	self:removeRegions(BidScrollFrame)
	self:skinScrollBar(BidScrollFrame)

	for k, v in pairs({ _G["BidQualitySort"], BidLevelSort, BidDurationSort, BidBuyoutSort, BidStatusSort, BidBidSort }) do
		self:keepFontStrings(v)
		self:storeAndSkin(ftype, v)
	end

	self:skinMoneyFrame(BidBidPrice)

-->>--	Auctions Frame
	self:moveObject(AuctionsTitle, nil, nil, "+", 6)
	self:storeAndSkin(ftype, AuctionsItemButton)
	self:removeRegions(AuctionsScrollFrame)
	self:skinScrollBar(AuctionsScrollFrame)

	for k, v in pairs({ AuctionsQualitySort, AuctionsDurationSort, AuctionsHighBidderSort, AuctionsBidSort }) do
		self:keepFontStrings(v)
		self:storeAndSkin(ftype, v)
	end

	self:skinMoneyFrame(StartPrice)
	self:skinMoneyFrame(BuyoutPrice)

	self:storeAndSkin(ftype, AuctionFrame)

-->>--	AuctionDressUp Frame
	self:keepRegions(AuctionDressUpFrame, {3, 4}) --N.B. regions 3 & 4 are the background
	AuctionDressUpFrame:SetWidth(AuctionDressUpFrame:GetWidth() - 6)
	AuctionDressUpFrame:SetHeight(AuctionDressUpFrame:GetHeight() - 13)
	self:moveObject(AuctionDressUpBackgroundTop, nil, nil, "+", 8)

	AuctionDressUpModelRotateLeftButton:Hide()
	AuctionDressUpModelRotateRightButton:Hide()
	self:makeMFRotatable(AuctionDressUpModel)

	self:keepRegions(AuctionDressUpFrameCloseButton, {1}) -- N.B. region 1 is the button artwork
	self:storeAndSkin(ftype, AuctionDressUpFrame)

end

function Skinner:AH_FilterButton_SetType(button, type, text, isLast)

	local normalText = getglobal(button:GetName().."NormalText")
	local normalTexture = getglobal(button:GetName().."NormalTexture")
	local line = getglobal(button:GetName().."Lines")

	if ( type == "class" ) then
		button:SetText(text)
		normalText:SetPoint("LEFT", button, "LEFT", 4, 0)
		--normalTexture:SetAlpha(1.0)
		line:Hide()
	elseif ( type == "subclass" ) then
		button:SetText(HIGHLIGHT_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE)
		--button:SetText("|cff007FFF"..text.."|r")
		normalText:SetPoint("LEFT", button, "LEFT", 12, 0)
		--normalTexture:SetAlpha(0.4)
		line:Hide()
	elseif ( type == "invtype" ) then
		button:SetText(HIGHLIGHT_FONT_COLOR_CODE..text..FONT_COLOR_CODE_CLOSE)
		normalText:SetPoint("LEFT", button, "LEFT", 20, 0)
		normalTexture:SetAlpha(0.0)
		if ( isLast ) then
			line:SetTexCoord(0.4375, 0.875, 0, 0.625)
		else
			line:SetTexCoord(0, 0.4375, 0, 0.625)
		end
		line:Show()
	end

	button.type = type

end

function Skinner:MainMenuBar()
	if not self.db.profile.MainMenuBar.skin or self.initialized.MainMenuBar then return end
	self.initialized.MainMenuBar = true

	-- Don't move the Performance Bar if IPopBar is loaded as it keeps moving up the screen
	if not IsAddOnLoaded("IPopBar") then
		-- hook this to move the PerformanceBar
		self:SecureHook("MainMenuBar_UpdateKeyRing", function()
			if SHOW_KEYRING == 1 then self:moveObject(MainMenuBarPerformanceBarFrame, nil, nil, "+", 4) end
			end)
	end

	-- Hook this to move the Reputation Watch Bar
	self:SecureHook("ReputationWatchBar_Update", function(newLevel)
		self:moveObject(ReputationWatchBar, nil, nil, "-", 4)
		end)

	self:keepFontStrings(MainMenuBar)
	if  not MainMenuBarMaxLevelBar:IsShown() then
		MainMenuBar:SetHeight(MainMenuBar:GetHeight() * 1.15)
		self:moveObject(ActionBarUpButton, nil, nil, "-", 4)
		self:moveObject(ActionBarDownButton, nil, nil, "-", 4)
	else
		self:moveObject(ActionBarUpButton, nil, nil, "+", 4)
		self:moveObject(ActionBarDownButton, nil, nil, "+", 4)
		self:moveObject(MainMenuBarPageNumber, nil, nil, "+", 4)
	end
	self:moveObject(MainMenuBar, nil, nil, "-", 4)
	self:storeAndSkin(ftype, MainMenuBar, nil, 0)
	LowerFrameLevel(MainMenuBar)

	-- Experience Bar
	self:keepRegions(MainMenuExpBar, {1, 7}) -- N.B. region 1 is rested XP, 7 is the normal XP
	MainMenuExpBar:SetWidth(MainMenuExpBar:GetWidth() - 8)
	MainMenuExpBar:SetHeight(MainMenuExpBar:GetHeight() * FyMult)
	self:moveObject(MainMenuExpBar, nil, nil, "-", 4)
	self:moveObject(MainMenuBarExpText, nil, nil, "-", 1)
	if self.db.profile.MainMenuBar.glazesb then self:glazeStatusBar(MainMenuExpBar, 0) end
	-- Reputation Bar
	self:keepRegions(ReputationWatchStatusBar, {10}) -- 10 is the normal texture
	ReputationWatchStatusBar:SetWidth(MainMenuExpBar:GetWidth())
	self:moveObject(ReputationWatchBar, nil, nil, "-", 4)
--	self:moveObject(ReputationWatchStatusBarText, nil, nil, "-", 3)
	if self.db.profile.MainMenuBar.glazesb then self:glazeStatusBar(ReputationWatchStatusBar, 0) end
-->>--	MainMenuBarOverlayFrame
	self:keepFontStrings(MainMenuBarMaxLevelBar)
	self:keepFontStrings(MainMenuBarArtFrame)
	self:moveObject(MainMenuBarPerformanceBarFrame, nil, nil, "+", 4)
	MainMenuBarPerformanceBarFrame:SetFrameStrata("MEDIUM")
	-- Exhaustion Bar (i.e. Rested)
	ExhaustionLevelFillBar:SetHeight(ExhaustionLevelFillBar:GetHeight() * FyMult)
	ExhaustionTick:SetAlpha(0)

	-- move Action Buttons, Micro buttons etc
	self:moveObject(ActionButton1, nil, nil, "+", 3)
	self:moveObject(CharacterMicroButton, nil, nil, "+", 4)
	self:moveObject(MainMenuBarBackpackButton, nil, nil, "+", 4)

-->>-- BonusActionBar Frame
	self:keepFontStrings(BonusActionBarFrame)
	self:moveObject(BonusActionButton1, nil, nil, "+", 3)
	if BonusActionBarFrame.mode == "show" then
		self:toggleActionButtons()
	end
	-- hook these to hide/show ActionButtons when shapeshifting (Druid/Rogue)
	self:SecureHook("ShowBonusActionBar", function(this, ...)
		self:toggleActionButtons()
		end)
	self:SecureHook("HideBonusActionBar", function(this, ...)
		self:toggleActionButtons()
		end)
-->>-- ShapeshiftBar Frame
	self:keepFontStrings(ShapeshiftBarFrame)

-->>-- PossessBar Frame
	self:keepFontStrings(PossessBarFrame)

-->>-- PetActionBar  Frame
	self:keepFontStrings(PetActionBarFrame)
	self:moveObject(PetActionButton1, nil, nil, "+", 4)

end

function Skinner:toggleActionButtons()

	local babf = BonusActionBarFrame

--	self:Debug("tAB: [%s, %s, %s, %s]", _G["ActionButton1"]:IsShown(),_G["BonusActionButton1"]:IsShown(), babf.mode,  babf.state)

	if babf.mode == "show" or (babf.mode == "none" and babf.state == "top") then
		for i = 1, 12 do
			_G["ActionButton"..i]:SetAlpha(0)
		end
	else
		for i = 1, 12 do
			_G["ActionButton"..i]:SetAlpha(1)
		end
	end

end

function Skinner:CoinPickup()
	if not self.db.profile.CoinPickup or self.initialized.CoinPickup then return end
	self.initialized.CoinPickup = true

	self:keepFontStrings(CoinPickupFrame)
	CoinPickupFrame:SetWidth(CoinPickupFrame:GetWidth() * 0.8)
	CoinPickupFrame:SetHeight(CoinPickupFrame:GetHeight() * 0.65)
	self:moveObject(CoinPickupGoldIcon, "+", 5, "-", 5)
	self:moveObject(CoinPickupSilverIcon, "+", 5, "-", 5)
	self:moveObject(CoinPickupCopperIcon, "+", 5, "-", 5)
	self:moveObject(CoinPickupText, "+", 5, "-", 5)
	self:moveObject(CoinPickupLeftButton, "+", 10, "-", 5)
	self:moveObject(CoinPickupRightButton, "-", 10, "-", 5)
	self:moveObject(CoinPickupOkayButton, "+", 3, "-", 13)
	self:moveObject(CoinPickupCancelButton, "-", 5, "-", 13)
	self:storeAndSkin(ftype, CoinPickupFrame)

end

function Skinner:GMSurveyUI()
	if not self.db.profile.GMSurveyUI or self.initialized.GMSurveyUI then return end
	self.initialized.GMSurveyUI = true

	self:keepFontStrings(GMSurveyFrame)
	self:keepFontStrings(GMSurveyHeader)

	for i = 1, MAX_SURVEY_QUESTIONS do
		self:storeAndSkin(ftype, _G["GMSurveyQuestion"..i])
	end
	self:storeAndSkin(ftype, GMSurveyCommentFrame)
	self:moveObject(GMSurveyHeaderText, nil, nil, "-", 6)
	self:moveObject(GMSurveyCloseButton, "+", 40, nil, nil)
	self:moveObject(GMSurveyCancelButton, nil, nil, "-", 10)
	self:moveObject(GMSurveySubmitButton, "+", 40, "-", 10)

	self:removeRegions(GMSurveyScrollFrame)
	self:skinScrollBar(GMSurveyScrollFrame)
	self:removeRegions(GMSurveyCommentScrollFrame)
	self:skinScrollBar(GMSurveyCommentScrollFrame)

	self:storeAndSkin(ftype, GMSurveyFrame, true)

end

function Skinner:LFGFrame()
	if not self.db.profile.LFGFrame or self.initialized.LFGFrame then return end
	self.initialized.LFGFrame = true

	if self.db.profile.TexturedTab then
		self:SecureHook("LFGParentFrameTab1_OnClick", function()
--			self:Debug("LFGParentFrameTab1_OnClick")
			self:setActiveTab(LFGParentFrameTab1)
			self:setInactiveTab(LFGParentFrameTab2)
			end)
		self:SecureHook("LFGParentFrameTab2_OnClick", function()
--			self:Debug("LFGParentFrameTab2_OnClick")
			self:setActiveTab(LFGParentFrameTab2)
			self:setInactiveTab(LFGParentFrameTab1)
			end)
	end

	-- hook these to move the comment
	self:SecureHook("LFMFrame_OnShow", function()
		self:moveObject(LFGComment, nil, nil, "-", 80)
		end)
	self:SecureHook("LFGFrame_OnShow", function()
		self:moveObject(LFGComment, nil, nil, "-", 80)
		end)

	LFGParentFrame:SetWidth(LFGParentFrame:GetWidth() * FxMult)
	LFGParentFrame:SetHeight(LFGParentFrame:GetHeight() * FyMult)
	-- move the close button
	self:moveObject(self:getChild(LFGParentFrame, 4), "+", 28, "+", 8)
	self:skinEditBox(LFGComment, {6})

-->>-- LFG Frame
	self:keepFontStrings(AutoJoinBackground)
	self:skinDropDown(LFGFrameNameDropDown1)
	self:skinDropDown(LFGFrameNameDropDown2)
	self:skinDropDown(LFGFrameNameDropDown3)
	self:skinDropDown(LFGFrameTypeDropDown1)
	self:skinDropDown(LFGFrameTypeDropDown2)
	self:skinDropDown(LFGFrameTypeDropDown3)
	self:moveObject(LFGSearchBg1, "+", 30, nil, nil)
	self:keepRegions(LFGEye, {})
	self:storeAndSkin(ftype, LFGEye)
	self:moveObject(LFGFrameDoneButton, "+", 25, "-", 76)

-->>-- LFM Frame
	self:keepFontStrings(AddMemberBackground)
	self:moveObject(LFMFrameTotals, nil, nil, "-", 76)
	self:skinDropDown(LFMFrameTypeDropDown)
	self:skinDropDown(LFMFrameNameDropDown)
	self:moveObject(LFMFrameTypeDropDown, "-", 10, nil, nil)
	self:skinFFColHeads("LFMFrameColumnHeader") --N.B. Prefix string
	self:moveObject(LFMFrameColumnHeader1, "-", 10, nil, nil)
	self:removeRegions(LFMListScrollFrame)
	self:skinScrollBar(LFMListScrollFrame)
	self:keepFontStrings(LFMEye)
	self:storeAndSkin(ftype, LFMEye)
	self:keepRegions(LFMFrame, {1})
	self:moveObject(LFMFrameGroupInviteButton, "+", 25, "-", 76)

-->>-- Tabs
	self:keepRegions(LFGParentFrameTab1, {7, 8})
	self:keepRegions(LFGParentFrameTab2, {7, 8})
	self:moveObject(LFGParentFrameTab1, nil, nil, "-", 70)
	self:moveObject(LFGParentFrameTab2, "+", 10, nil, nil)
	if self.db.profile.TexturedTab then self:applySkin(LFGParentFrameTab1, nil, 0)
	else self:storeAndSkin(ftype, LFGParentFrameTab1) end
	if self.db.profile.TexturedTab then self:applySkin(LFGParentFrameTab2, nil, 0)
	else self:storeAndSkin(ftype, LFGParentFrameTab2) end

	self:keepFontStrings(LFGParentFrame)
	self:storeAndSkin(ftype, LFGParentFrame)

end

function Skinner:ItemSocketingUI()
	if not self.db.profile.ItemSocketingUI or self.initialized.ItemSocketingUI then return end
	self.initialized.ItemSocketingUI = true

	self:SecureHook("ItemSocketingFrame_Update", function()
		for i = 1, GetNumSockets() do
			-- colour the button border
			local colour = GEM_TYPE_INFO[GetSocketTypes(i)]
			_G["ItemSocketingSocket"..i].sBut:SetBackdropBorderColor(colour.r, colour.g, colour.b)
		end
		end)

	ItemSocketingFrame:SetWidth(CharacterFrame:GetWidth())
	ItemSocketingFrame:SetHeight(CharacterFrame:GetHeight())
	self:moveObject(ItemSocketingCloseButton, nil, nil, "+", 8)
	self:removeRegions(ItemSocketingScrollFrame)
	self:skinScrollBar(ItemSocketingScrollFrame)
	for i = 1, MAX_NUM_SOCKETS do
		local isB = _G["ItemSocketingSocket"..i]
		_G["ItemSocketingSocket"..i.."Left"]:SetAlpha(0)
		_G["ItemSocketingSocket"..i.."Right"]:SetAlpha(0)
		_G["ItemSocketingSocket"..i.."BracketFrame"]:Hide()
		self:getRegion(isB, 3):SetAlpha(0) -- button texture
		self:addSkinButton(isB)
	end
	self:moveObject(ItemSocketingSocketButton, nil, nil, "-", 20)
	self:keepFontStrings(ItemSocketingFrame)
	self:storeAndSkin(ftype, ItemSocketingFrame)

	if self.db.profile.Tooltips.skin then
		if self.db.profile.Tooltips.style == 3 then ItemSocketingDescription:SetBackdrop(backdrop) end
		self:skinTooltip(ItemSocketingDescription)
	end

end

function Skinner:GuildBankUI()
	if not self.db.profile.GuildBankUI or self.initialized.GuildBankUI then return end
	self.initialized.GuildBankUI = true

-->>-- Main Frame
	GuildBankEmblemFrame:Hide()
	self:keepFontStrings(GuildBankFrame)
	self:moveObject(GuildBankTabTitle, nil, nil, "+", 20)
	self:moveObject(self:getChild(GuildBankFrame, 13), "-", 2, "+", 9) -- Close Button
	self:moveObject(GuildBankColumn1, "-", 5, "+", 10)
	for i = 1, 7 do
		_G["GuildBankColumn"..i.."Background"]:SetAlpha(0)
	end
	self:storeAndSkin(ftype, GuildBankFrame, true)
-->>-- Log Frame
	self:removeRegions(GuildBankTransactionsScrollFrame)
	self:skinScrollBar(GuildBankTransactionsScrollFrame)
-->>-- Info Frame
	self:removeRegions(GuildBankInfoScrollFrame)
	self:skinScrollBar(GuildBankInfoScrollFrame)

--	GuildBank Tabs (on the RHS)
	for i = 1, 6 do
		local tabName = _G["GuildBankTab"..i]
		self:keepRegions(tabName, {7, 8})
		if i == 1 then self:moveObject(tabName, "-", 2, nil, nil) end
	end

--	GuildBank Frame Tabs (at the bottom)
	for i = 1, MAX_GUILDBANK_TABS do
		local tabName = _G["GuildBankFrameTab"..i]
		self:keepFontStrings(tabName)
		if self.db.profile.TexturedTab then
			self:applySkin(tabName, nil, 0, 1)
			if i == 1 then self:setActiveTab(tabName)
			else self:setInactiveTab(tabName) end
		else self:storeAndSkin(ftype, tabName) end
		if i == 1 then self:moveObject(tabName, nil, nil, "-", 2)
		else self:moveObject(tabName, "+", 13, nil, nil) end
	end

	if self.db.profile.TexturedTab then
		self:SecureHook("GuildBankFrameTab_OnClick", function(id, doNotUpdate)
			for i = 1, 4 do
				local tabName = _G["GuildBankFrameTab"..i]
				if i == GuildBankFrame.selectedTab then self:setActiveTab(tabName)
				else self:setInactiveTab(tabName) end
			end
			end)
	end


-->>-- GuildBank Popup Frame
	self:keepFontStrings(GuildBankPopupFrame)
	self:skinEditBox(GuildBankPopupEditBox, {9})
	self:removeRegions(GuildBankPopupScrollFrame)
	self:skinScrollBar(GuildBankPopupScrollFrame)
	self:moveObject(GuildBankPopupScrollFrame, "+", 18, nil, nil)
	self:moveObject(GuildBankPopupButton1, "+", 18, nil, nil)
	self:moveObject(GuildBankPopupCancelButton, "-", 12, "-", 14)
	self:storeAndSkin(ftype, GuildBankPopupFrame, true)

end

function Skinner:Nameplates()
	if not self.db.profile.Nameplates or self.initialized.Nameplates then return end
	self.initialized.Nameplates = true
--	self:Debug("Nameplates: [%s, %s]", NAMEPLATES_ON, FRIENDNAMEPLATES_ON)

	if (NAMEPLATES_ON or FRIENDNAMEPLATES_ON) then
		self:ScheduleEvent(self.skinNameplates, 0.2, self) -- use a .2 second delay so nameplates exist
	else
		self:hookShowNameplates()
	end

end

function Skinner:skinNameplates()
--	self:Debug("skinNameplates")

	for _, child in pairs({WorldFrame:GetChildren()}) do
		if self:isNameplate(child) then
--			self:Debug("skinNameplates: [%s]", child)
--			self:ShowInfo(child)
			self:removeRegions(child, {1, 2, 4}) -- remove border textures and the glow effect
			if not child.skinned then
				for i = 1, 2 do -- skin both status bars
					local sb = self:getChild(child, i)
					self:glazeStatusBar(sb, 0)
					sb:SetFrameStrata("LOW") -- make sure the status bar appears above the background frame
					sb.bg:SetFrameStrata("BACKGROUND")
				end
				child.skinned = true
			end
		end
	end

	if not self:IsEventScheduled("NameplateUpdateCheck") then
		self:ScheduleRepeatingEvent("NameplateUpdateCheck", self.skinNameplates, 0.2, self)
	end

	if not self:IsHooked("HideNameplates") then
		self:hookHideNameplates()
	end

end

function Skinner:hookShowNameplates()

	self:SecureHook("ShowNameplates", function()
		self:ScheduleEvent(self.skinNameplates, 0.2, self)
		end)
	self:SecureHook("ShowFriendNameplates", function()
		self:ScheduleEvent(self.skinNameplates, 0.2, self)
		end)

end

function Skinner:hookHideNameplates()

	self:SecureHook("HideNameplates", function()
		if not (NAMEPLATES_ON and FRIENDNAMEPLATES_ON) then
			if self:IsEventScheduled("NameplateUpdateCheck") then
				self:CancelScheduledEvent("NameplateUpdateCheck")
			end
			if not self:IsHooked("ShowNameplates") then
				self:hookShowNameplates()
			end
		end
		end)
	self:SecureHook("HideFriendNameplates", function()
		if not (NAMEPLATES_ON and FRIENDNAMEPLATES_ON) then
			if self:IsEventScheduled("NameplateUpdateCheck") then
				self:CancelScheduledEvent("NameplateUpdateCheck")
			end
			if not self:IsHooked("ShowNameplates") then
				self:hookShowNameplates()
			end
		end
		end)

end
